;CodeVisionAVR C Compiler V1.0.0.8v Evaluation
;(C) Copyright 1998-2000 Pavel Haiduc, HP InfoTech S.R.L.
;http://infotech.ir.ro
;e-mail:dhptechn@ir.ro , hpinfotech@mail.com

;Chip type        : AT90S2313
;Clock frequency  : 10,000000 MHz
;Memory model     : Tiny
;Internal RAM size: 128
;External RAM size: 0
;Data Stack size  : 64
;Automatic register allocation: On
;Use AVR Studio Terminal I/O  : No

	.DEVICE AT90S2313
	.LISTMAC
	.EQU UDRE=5
	.EQU RXC=7
	.EQU UBRR=9
	.EQU UCR=0xA
	.EQU USR=0xB
	.EQU UDR=0xC
	.EQU EERE=0
	.EQU EEWE=1
	.EQU EEMWE=2
	.EQU SPSR=0xE
	.EQU SPDR=0xF
	.EQU EECR=0x1C
	.EQU EEDR=0x1D
	.EQU EEARL=0x1E
	.EQU EEARH=0x1F
	.EQU WDTCR=0x21
	.EQU MCUCR=0x35
	.EQU RAMPZ=0x3B
	.EQU SPL=0x3D
	.EQU SPH=0x3E
	.EQU SREG=0x3F
	.DEF R0X2=R2
	.DEF R0X3=R3
	.DEF R0X4=R4
	.DEF R0X5=R5
	.DEF R0X6=R6
	.DEF R0X7=R7
	.DEF R0X8=R8
	.DEF R0X9=R9
	.DEF R0XA=R10
	.DEF R0XB=R11
	.DEF R0XC=R12
	.DEF R0XD=R13
	.DEF R0XE=R14
	.DEF R0XF=R15
	.DEF R0X10=R16
	.DEF R0X11=R17
	.DEF R0X12=R18
	.DEF R0X13=R19
	.DEF R0X14=R20
	.DEF R0X15=R21
	.EQU __se_bit=0x20
	.EQU __sm_mask=0x10

	.MACRO __EQB10
	TST  R30
	BREQ __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __GEB10
	CPI  R30,0
	BRGE __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __GTB10
	CLR  R0
	CP   R0,R30
	BRLT __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __LEB10
	CLR  R0
	CP   R0,R30
	BRGE __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __LTB10
	CPI  R30,0
	BRLT __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __NEB10
	TST  R30
	BRNE __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __EQW10
	SBIW R30,0
	BREQ __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __GEW10
	SBIW R30,0
	BRGE __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __GTW10
	RCALL __CPW01
	BRLT __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __LEW10
	RCALL __CPW01
	BRGE __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __LTW10
	SBIW R30,0
	BRLT __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __NEW10
	SBIW R30,0
	BRNE __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __EQD10
	RCALL __CPD10
	BREQ __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __GED10
	RCALL __CPD10
	BRGE __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __GTD10
	RCALL __CPD01
	BRLT __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __LED10
	RCALL __CPD01
	BRGE __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __LTD10
	RCALL __CPD10
	BRLT __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __NED10
	RCALL __CPD10
	BRNE __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __EQB12J
	CP   R30,R26
	BREQ __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __NEB12J
	CP   R30,R26
	BRNE __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __LEB12J
	CP   R30,R26
	BRGE __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __GEB12J
	CP   R26,R30
	BRGE __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __LTB12J
	CP   R26,R30
	BRLT __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __GTB12J
	CP   R30,R26
	BRLT __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __LEB12UJ
	CP   R30,R26
	BRSH __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __GEB12UJ
	CP   R26,R30
	BRSH __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __LTB12UJ
	CP   R26,R30
	BRLO __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __GTB12UJ
	CP   R30,R26
	BRLO __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __EQW12J
	CP   R30,R26
	CPC  R31,R27
	BREQ __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __NEW12J
	CP   R30,R26
	CPC  R31,R27
	BRNE __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __LEW12J
	CP   R30,R26
	CPC  R31,R27
	BRGE __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __GEW12J
	CP   R26,R30
	CPC  R27,R31
	BRGE __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __LTW12J
	CP   R26,R30
	CPC  R27,R31
	BRLT __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __GTW12J
	CP   R30,R26
	CPC  R31,R27
	BRLT __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __LEW12UJ
	CP   R30,R26
	CPC  R31,R27
	BRSH __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __GEW12UJ
	CP   R26,R30
	CPC  R27,R31
	BRSH __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __LTW12UJ
	CP   R26,R30
	CPC  R27,R31
	BRLO __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __GTW12UJ
	CP   R30,R26
	CPC  R31,R27
	BRLO __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __EQD12J
	RCALL __CPD12
	BREQ __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __NED12J
	RCALL __CPD12
	BRNE __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __LED12J
	RCALL __CPD12
	BRGE __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __GED12J
	RCALL __CPD21
	BRGE __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __LTD12J
	RCALL __CPD21
	BRLT __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __GTD12J
	RCALL __CPD12
	BRLT __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __LED12UJ
	RCALL __CPD12
	BRSH __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __GED12UJ
	RCALL __CPD21
	BRSH __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __LTD12UJ
	RCALL __CPD21
	BRLO __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __GTD12UJ
	RCALL __CPD12
	BRLO __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __LEF12J
	RCALL __CMPF12
	BREQ __TRUE
	BRCS __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __GEF12J
	RCALL __CMPF12
	BREQ __TRUE
	BRCC __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __LTF12J
	RCALL __CMPF12
	BREQ __FALSE
	BRCS __TRUE
__FALSE:
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __GTF12J
	RCALL __CMPF12
	BREQ __FALSE
	BRCC __TRUE
__FALSE:
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __EQB1NJ
	CPI  R30,LOW(@1)
	BREQ __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __NEB1NJ
	CPI  R30,LOW(@1)
	BRNE __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __EQB2NJ
	CPI  R26,LOW(@1)
	BREQ __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __NEB2NJ
	CPI  R26,LOW(@1)
	BRNE __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __LEB1NJ
	CPI  R30,LOW(@1)
	BRGE __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __GTB1NJ
	CPI  R30,LOW(@1)
	BRLT __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __GEB1NJ
	CPI  R30,LOW(@1)
	BRGE __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __LTB1NJ
	CPI  R30,LOW(@1)
	BRLT __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __LEB1NUJ
	CPI  R30,LOW(@1)
	BRSH __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __GTB1NUJ
	CPI  R30,LOW(@1)
	BRLO __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __GEB1NUJ
	CPI  R30,LOW(@1)
	BRSH __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __LTB1NUJ
	CPI  R30,LOW(@1)
	BRLO __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __GEB2NJ
	CPI  R26,LOW(@1)
	BRGE __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __LTB2NJ
	CPI  R26,LOW(@1)
	BRLT __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __GEB2NUJ
	CPI  R26,LOW(@1)
	BRSH __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __LTB2NUJ
	CPI  R26,LOW(@1)
	BRLO __TRUE
	RJMP _@0
__TRUE:
	.ENDM

	.MACRO __BITSREG0
	BRBC @0,__TRUE
	RJMP _@1
__TRUE:
	.ENDM

	.MACRO __BITSREG1
	BRBS @0,__TRUE
	RJMP _@1
__TRUE:
	.ENDM

	.MACRO __EQBR0
	TST  R@0
	BREQ __TRUE
	RJMP _@1
__TRUE:
	.ENDM

	.MACRO __GEBR0
	TST  R@0
	BRGE __TRUE
	RJMP _@1
__TRUE:
	.ENDM

	.MACRO __GTBR0
	CLR  R0
	CP   R0,R@0
	BRLT __TRUE
	RJMP _@1
__TRUE:
	.ENDM

	.MACRO __LEBR0
	CLR  R0
	CP   R0,R@0
	BRGE __TRUE
	RJMP _@1
__TRUE:
	.ENDM

	.MACRO __LTBR0
	TST  R@0
	BRLT __TRUE
	RJMP _@1
__TRUE:
	.ENDM

	.MACRO __NEBR0
	TST  R@0
	BRNE __TRUE
	RJMP _@1
__TRUE:
	.ENDM

	.MACRO __EQBRRJ
	CP   R@0,R@1
	BREQ __TRUE
	RJMP _@2
__TRUE:
	.ENDM

	.MACRO __NEBRRJ
	CP   R@0,R@1
	BRNE __TRUE
	RJMP _@2
__TRUE:
	.ENDM

	.MACRO __LEBRRJ
	CP   R@0,R@1
	BRGE __TRUE
	RJMP _@2
__TRUE:
	.ENDM

	.MACRO __GEBRRJ
	CP   R@1,R@0
	BRGE __TRUE
	RJMP _@2
__TRUE:
	.ENDM

	.MACRO __LTBRRJ
	CP   R@1,R@0
	BRLT __TRUE
	RJMP _@2
__TRUE:
	.ENDM

	.MACRO __GTBRRJ
	CP   R@0,R@1
	BRLT __TRUE
	RJMP _@2
__TRUE:
	.ENDM

	.MACRO __LEBRRUJ
	CP   R@0,R@1
	BRSH __TRUE
	RJMP _@2
__TRUE:
	.ENDM

	.MACRO __GEBRRUJ
	CP   R@1,R@0
	BRSH __TRUE
	RJMP _@2
__TRUE:
	.ENDM

	.MACRO __LTBRRUJ
	CP   R@1,R@0
	BRLO __TRUE
	RJMP _@2
__TRUE:
	.ENDM

	.MACRO __GTBRRUJ
	CP   R@0,R@1
	BRLO __TRUE
	RJMP _@2
__TRUE:
	.ENDM

	.MACRO __EQWRRJ
	CP   R@0,R@2
	CPC  R@1,R@3
	BREQ __TRUE
	RJMP _@4
__TRUE:
	.ENDM

	.MACRO __NEWRRJ
	CP   R@0,R@2
	CPC  R@1,R@3
	BRNE __TRUE
	RJMP _@4
__TRUE:
	.ENDM

	.MACRO __LEWRRJ
	CP   R@0,R@2
	CPC  R@1,R@3
	BRGE __TRUE
	RJMP _@4
__TRUE:
	.ENDM

	.MACRO __GEWRRJ
	CP   R@2,R@0
	CPC  R@3,R@1
	BRGE __TRUE
	RJMP _@4
__TRUE:
	.ENDM

	.MACRO __LTWRRJ
	CP   R@2,R@0
	CPC  R@3,R@1
	BRLT __TRUE
	RJMP _@4
__TRUE:
	.ENDM

	.MACRO __GTWRRJ
	CP   R@0,R@2
	CPC  R@1,R@3
	BRLT __TRUE
	RJMP _@4
__TRUE:
	.ENDM

	.MACRO __LEWRRUJ
	CP   R@0,R@2
	CPC  R@1,R@3
	BRSH __TRUE
	RJMP _@4
__TRUE:
	.ENDM

	.MACRO __GEWRRUJ
	CP   R@2,R@0
	CPC  R@3,R@1
	BRSH __TRUE
	RJMP _@4
__TRUE:
	.ENDM

	.MACRO __LTWRRUJ
	CP   R@2,R@0
	CPC  R@3,R@1
	BRLO __TRUE
	RJMP _@4
__TRUE:
	.ENDM

	.MACRO __GTWRRUJ
	CP   R@0,R@2
	CPC  R@1,R@3
	BRLO __TRUE
	RJMP _@4
__TRUE:
	.ENDM

	.MACRO __LEB1RJ
	CP   R30,R@0
	BRGE __TRUE
	RJMP _@1
__TRUE:
	.ENDM

	.MACRO __GEB1RJ
	CP   R@0,R30
	BRGE __TRUE
	RJMP _@1
__TRUE:
	.ENDM

	.MACRO __LTB1RJ
	CP   R@0,R30
	BRLT __TRUE
	RJMP _@1
__TRUE:
	.ENDM

	.MACRO __GTB1RJ
	CP   R30,R@0
	BRLT __TRUE
	RJMP _@1
__TRUE:
	.ENDM

	.MACRO __LEB1RUJ
	CP   R30,R@0
	BRSH __TRUE
	RJMP _@1
__TRUE:
	.ENDM

	.MACRO __GEB1RUJ
	CP   R@0,R30
	BRSH __TRUE
	RJMP _@1
__TRUE:
	.ENDM

	.MACRO __LTB1RUJ
	CP   R@0,R30
	BRLO __TRUE
	RJMP _@1
__TRUE:
	.ENDM

	.MACRO __GTB1RUJ
	CP   R30,R@0
	BRLO __TRUE
	RJMP _@1
__TRUE:
	.ENDM

	.MACRO __LEBR2J
	CP   R@0,R26
	BRGE __TRUE
	RJMP _@1
__TRUE:
	.ENDM

	.MACRO __GEBR2J
	CP   R26,R@0
	BRGE __TRUE
	RJMP _@1
__TRUE:
	.ENDM

	.MACRO __LTBR2J
	CP   R26,R@0
	BRLT __TRUE
	RJMP _@1
__TRUE:
	.ENDM

	.MACRO __GTBR2J
	CP   R@0,R26
	BRLT __TRUE
	RJMP _@1
__TRUE:
	.ENDM

	.MACRO __LEBR2UJ
	CP   R@0,R26
	BRSH __TRUE
	RJMP _@1
__TRUE:
	.ENDM

	.MACRO __GEBR2UJ
	CP   R26,R@0
	BRSH __TRUE
	RJMP _@1
__TRUE:
	.ENDM

	.MACRO __LTBR2UJ
	CP   R26,R@0
	BRLO __TRUE
	RJMP _@1
__TRUE:
	.ENDM

	.MACRO __GTBR2UJ
	CP   R@0,R26
	BRLO __TRUE
	RJMP _@1
__TRUE:
	.ENDM

	.MACRO __LEW1RJ
	CP   R30,R@0
	CPC  R31,R@1
	BRGE __TRUE
	RJMP _@2
__TRUE:
	.ENDM

	.MACRO __GEW1RJ
	CP   R@0,R30
	CPC  R@1,R31
	BRGE __TRUE
	RJMP _@2
__TRUE:
	.ENDM

	.MACRO __LTW1RJ
	CP   R@0,R30
	CPC  R@1,R31
	BRLT __TRUE
	RJMP _@2
__TRUE:
	.ENDM

	.MACRO __GTW1RJ
	CP   R30,R@0
	CPC  R31,R@1
	BRLT __TRUE
	RJMP _@2
__TRUE:
	.ENDM

	.MACRO __LEW1RUJ
	CP   R30,R@0
	CPC  R31,R@1
	BRSH __TRUE
	RJMP _@2
__TRUE:
	.ENDM

	.MACRO __GEW1RUJ
	CP   R@0,R30
	CPC  R@1,R31
	BRSH __TRUE
	RJMP _@2
__TRUE:
	.ENDM

	.MACRO __LTW1RUJ
	CP   R@0,R30
	CPC  R@1,R31
	BRLO __TRUE
	RJMP _@2
__TRUE:
	.ENDM

	.MACRO __GTW1RUJ
	CP   R30,R@0
	CPC  R31,R@1
	BRLO __TRUE
	RJMP _@2
__TRUE:
	.ENDM

	.MACRO __LEWR2J
	CP   R@0,R26
	CPC  R@1,R27
	BRGE __TRUE
	RJMP _@2
__TRUE:
	.ENDM

	.MACRO __GEWR2J
	CP   R26,R@0
	CPC  R27,R@1
	BRGE __TRUE
	RJMP _@2
__TRUE:
	.ENDM

	.MACRO __LTWR2J
	CP   R26,R@0
	CPC  R27,R@1
	BRLT __TRUE
	RJMP _@2
__TRUE:
	.ENDM

	.MACRO __GTWR2J
	CP   R@0,R26
	CPC  R@1,R27
	BRLT __TRUE
	RJMP _@2
__TRUE:
	.ENDM

	.MACRO __LEWR2UJ
	CP   R@0,R26
	CPC  R@1,R27
	BRSH __TRUE
	RJMP _@2
__TRUE:
	.ENDM

	.MACRO __GEWR2UJ
	CP   R26,R@0
	CPC  R27,R@1
	BRSH __TRUE
	RJMP _@2
__TRUE:
	.ENDM

	.MACRO __LTWR2UJ
	CP   R26,R@0
	CPC  R27,R@1
	BRLO __TRUE
	RJMP _@2
__TRUE:
	.ENDM

	.MACRO __GTWR2UJ
	CP   R@0,R26
	CPC  R@1,R27
	BRLO __TRUE
	RJMP _@2
__TRUE:
	.ENDM

	.MACRO __EQBRNJ
	CPI  R@0,LOW(@2)
	BREQ __TRUE
	RJMP _@1
__TRUE:
	.ENDM

	.MACRO __NEBRNJ
	CPI  R@0,LOW(@2)
	BRNE __TRUE
	RJMP _@1
__TRUE:
	.ENDM

	.MACRO __LEBRNJ
	CPI  R@0,LOW(@2)
	BRGE __TRUE
	RJMP _@1
__TRUE:
	.ENDM

	.MACRO __GEBRNJ
	CPI  R@0,LOW(@2)
	BRGE __TRUE
	RJMP _@1
__TRUE:
	.ENDM

	.MACRO __LTBRNJ
	CPI  R@0,LOW(@2)
	BRLT __TRUE
	RJMP _@1
__TRUE:
	.ENDM

	.MACRO __GTBRNJ
	CPI  R@0,LOW(@2)
	BRLT __TRUE
	RJMP _@1
__TRUE:
	.ENDM

	.MACRO __LEBRNUJ
	CPI  R@0,LOW(@2)
	BRSH __TRUE
	RJMP _@1
__TRUE:
	.ENDM

	.MACRO __GEBRNUJ
	CPI  R@0,LOW(@2)
	BRSH __TRUE
	RJMP _@1
__TRUE:
	.ENDM

	.MACRO __LTBRNUJ
	CPI  R@0,LOW(@2)
	BRLO __TRUE
	RJMP _@1
__TRUE:
	.ENDM

	.MACRO __GTBRNUJ
	CPI  R@0,LOW(@2)
	BRLO __TRUE
	RJMP _@1
__TRUE:
	.ENDM

	.MACRO __ADDD1N
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	SBCI R22,BYTE3(-@0)
	SBCI R23,BYTE4(-@0)
	.ENDM

	.MACRO __ADDD2N
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	SBCI R24,BYTE3(-@0)
	SBCI R25,BYTE4(-@0)
	.ENDM

	.MACRO __SUBD1N
	SUBI R30,LOW(@0)
	SBCI R31,HIGH(@0)
	SBCI R22,BYTE3(@0)
	SBCI R23,BYTE4(@0)
	.ENDM

	.MACRO __SUBD2N
	SUBI R26,LOW(@0)
	SBCI R27,HIGH(@0)
	SBCI R24,BYTE3(@0)
	SBCI R25,BYTE4(@0)
	.ENDM

	.MACRO __ANDD1N
	ANDI R30,LOW(@0)
	ANDI R31,HIGH(@0)
	ANDI R22,BYTE3(@0)
	ANDI R23,BYTE4(@0)
	.ENDM

	.MACRO __ORD1N
	ORI  R30,LOW(@0)
	ORI  R31,HIGH(@0)
	ORI  R22,BYTE3(@0)
	ORI  R23,BYTE4(@0)
	.ENDM

	.MACRO __DELAY_USB
	LDI  R24,LOW(@0)
__DELAY_USB_LOOP:
	DEC  R24
	BRNE __DELAY_USB_LOOP
	.ENDM

	.MACRO __DELAY_USW
	LDI  R24,LOW(@0)
	LDI  R25,HIGH(@0)
__DELAY_USW_LOOP:
	SBIW R24,1
	BRNE __DELAY_USW_LOOP
	.ENDM

	.MACRO __CLRD1S
	CLR  R30
	STD  Y+@0,R30
	STD  Y+@0+1,R30
	STD  Y+@0+2,R30
	STD  Y+@0+3,R30
	.ENDM

	.MACRO __GETD1S
	LDD  R30,Y+@0
	LDD  R31,Y+@0+1
	LDD  R22,Y+@0+2
	LDD  R23,Y+@0+3
	.ENDM

	.MACRO __PUTD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R31
	STD  Y+@0+2,R22
	STD  Y+@0+3,R23
	.ENDM

	.MACRO __POINTB1MN
	LDI  R30,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW1MN
	LDI  R30,LOW(@0+@1)
	LDI  R31,HIGH(@0+@1)
	.ENDM

	.MACRO __POINTW1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	.ENDM

	.MACRO __POINTB2MN
	LDI  R26,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW2MN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	.ENDM

	.MACRO __GETD1N
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __GETD2N
	LDI  R26,LOW(@0)
	LDI  R27,HIGH(@0)
	LDI  R24,BYTE3(@0)
	LDI  R25,BYTE4(@0)
	.ENDM

	.MACRO __GETD2S
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	LDD  R24,Y+@0+2
	LDD  R25,Y+@0+3
	.ENDM

	.MACRO __GETB1MN
	LDS  R30,@0+@1
	.ENDM

	.MACRO __GETW1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	.ENDM

	.MACRO __GETD1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	LDS  R22,@0+@1+2
	LDS  R23,@0+@1+3
	.ENDM

	.MACRO __GETBRMN
	LDS  R@2,@0+@1
	.ENDM

	.MACRO __GETWRMN
	LDS  R@2,@0+@1
	LDS  R@3,@0+@1+1
	.ENDM

	.MACRO __GETB2MN
	LDS  R26,@0+@1
	.ENDM

	.MACRO __GETW2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	.ENDM

	.MACRO __PUTB1MN
	STS  @0+@1,R30
	.ENDM

	.MACRO __PUTW1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	.ENDM

	.MACRO __PUTD1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	STS  @0+@1+2,R22
	STS  @0+@1+3,R23
	.ENDM

	.MACRO __PUTBMRN
	STS  @0+@1,R@2
	.ENDM

	.MACRO __PUTWMRN
	STS  @0+@1,R@2
	STS  @0+@1+1,R@3
	.ENDM

	.MACRO __TESTSREG
	LDI  R30,1
	BRBS @0,__TRUE
	LDI  R30,0
__TRUE:
	.ENDM

	.MACRO __NTESTSREG
	LDI  R30,1
	BRBC @0,__TRUE
	LDI  R30,0
__TRUE:
	.ENDM

	.MACRO __GETW1R
	MOV  R30,R@0
	MOV  R31,R@1
	.ENDM

	.MACRO __GETW2R
	MOV  R26,R@0
	MOV  R27,R@1
	.ENDM

	.MACRO __GETWRN
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __PUTW1R
	MOV  R@0,R30
	MOV  R@1,R31
	.ENDM

	.MACRO __ADDWRN
	SUBI R@0,LOW(-@2)
	SBCI R@1,HIGH(-@2)
	.ENDM

	.MACRO __SUBWRN
	SUBI R@0,LOW(@2)
	SBCI R@1,HIGH(@2)
	.ENDM

	.MACRO __ANDWRN
	ANDI R@0,LOW(@2)
	ANDI R@1,HIGH(@2)
	.ENDM

	.MACRO __ORWRN
	ORI  R@0,LOW(@2)
	ORI  R@1,HIGH(@2)
	.ENDM

	.MACRO __GETWRS
	LDD  R@0,Y+@2
	LDD  R@1,Y+@2+1
	.ENDM

	.MACRO __PUTWSR
	STD  Y+@2,R@0
	STD  Y+@2+1,R@1
	.ENDM

	.MACRO __MOVEWRR
	MOV  R@0,R@2
	MOV  R@1,R@3
	.ENDM

	.MACRO __INWR
	IN   R@0,@2
	IN   R@1,@2+1
	.ENDM

	.MACRO __OUTWR
	OUT  @2+1,R@1
	OUT  @2,R@0
	.ENDM

	.MACRO __CALL1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	ICALL
	.ENDM

	.CSEG
	.ORG 0x0B

__RESET:
	CLI
	CLR  R30
	OUT  EECR,R30

;DISABLE WATCHDOG
	LDI  R30,0x18
	OUT  WDTCR,R30
	LDI  R30,0x10
	OUT  WDTCR,R30
	CLR  R30
	OUT  MCUCR,R30

;CLEAR R2-R15
	LDI  R24,14
	LDI  R26,2
__CLEAR_REG:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_REG

;CLEAR RAM
	LDI  R24,LOW(0x80)
	LDI  R26,0x60
__CLEAR_RAM:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_RAM

;GLOBAL VARIABLES INITIALIZATION
	LDI  R30,LOW(__GLOBAL_INI_TBL*2)
	LDI  R31,HIGH(__GLOBAL_INI_TBL*2)
__GLOBAL_INI_NEXT:
	LPM
	MOV  R1,R0
	ADIW R30,1
	LPM
	ADIW R30,1
	MOV  R22,R30
	MOV  R23,R31
	MOV  R31,R0
	MOV  R30,R1
	SBIW R30,0
	BREQ __GLOBAL_INI_END
	LPM
	MOV  R26,R0
	ADIW R30,1
	LPM
	MOV  R27,R0
	ADIW R30,1
	LPM
	MOV  R24,R0
	ADIW R30,1
	LPM
	MOV  R25,R0
	ADIW R30,1
__GLOBAL_INI_LOOP:
	LPM
	ST   X+,R0
	ADIW R30,1
	SBIW R24,1
	BRNE __GLOBAL_INI_LOOP
	MOV  R30,R22
	MOV  R31,R23
	RJMP __GLOBAL_INI_NEXT
__GLOBAL_INI_END:

;STACK POINTER INITIALIZATION
	LDI  R30,LOW(0xDF)
	OUT  SPL,R30

;DATA STACK POINTER INITIALIZATION
	LDI  R28,LOW(0x9F)

	RJMP  _main

	.ESEG
	.ORG 1

	.DSEG
	.ORG 0xA0
;       1 /*
;       2 Chip type           : AT90S2313
;       3 Clock frequency     : 2,000000 MHz
;       4 Memory model        : Tiny
;       5 Internal SRAM size  : 128
;       6 External SRAM size  : 0
;       7 Data Stack size     : 32
;       8 *********************************************/
;       9 
;      10 #include <90s2313.h>
;      11 // CodeVisionAVR C Compiler
;      12 // (C) 1998-2000 Pavel Haiduc, HP InfoTech S.R.L.
;      13 
;      14 // I/O registers definitions for the AT90S2313
;      15 
;      16 #pragma used+
;      17 sfrb ACSR=8;
;      18 sfrb UBRR=9;
;      19 sfrb UCR=0xa;
;      20 sfrb USR=0xb;
;      21 sfrb UDR=0xc;
;      22 sfrb PIND=0x10;
;      23 sfrb DDRD=0x11;
;      24 sfrb PORTD=0x12;
;      25 sfrb PINB=0x16;
;      26 sfrb DDRB=0x17;
;      27 sfrb PORTB=0x18;
;      28 sfrb EECR=0x1c;
;      29 sfrb EEDR=0x1d;
;      30 sfrb EEAR=0x1e;
;      31 sfrb WDTCR=0x21;
;      32 sfrb ICR1L=0x24;
;      33 sfrb ICR1H=0x25;
;      34 sfrw ICR1=0x24;  // 16 bit access
;      35 sfrb OCR1L=0x2a;
;      36 sfrb OCR1H=0x2b;
;      37 sfrw OCR1=0x2a;  // 16 bit access
;      38 sfrb TCNT1L=0x2c;
;      39 sfrb TCNT1H=0x2d;
;      40 sfrw TCNT1=0x2c; // 16 bit access
;      41 sfrb TCCR1B=0x2e;
;      42 sfrb TCCR1A=0x2f;
;      43 sfrb TCNT0=0x32;
;      44 sfrb TCCR0=0x33;
;      45 sfrb MCUSR=0x34;
;      46 sfrb MCUCR=0x35;
;      47 sfrb TIFR=0x38;
;      48 sfrb TIMSK=0x39;
;      49 sfrb GIFR=0x3a;
;      50 sfrb GIMSK=0x3b;
;      51 sfrb SPL=0x3d;
;      52 sfrb SREG=0x3f;
;      53 #pragma used-
;      54 
;      55 #define OCR1AL OCR1L
;      56 #define OCR1AH OCR1H
;      57 
;      58 // Interrupt vectors definitions
;      59 
;      60 #define EXT_INT0 2
;      61 #define EXT_INT1 3
;      62 #define TIM1_CAPT 4
;      63 #define TIM1_COMP 5
;      64 #define TIM1_OVF 6
;      65 #define TIM0_OVF 7
;      66 #define UART_RXC 8
;      67 #define UART_DRE 9
;      68 #define UART_TXC 10
;      69 #define ANA_COMP 11
;      70 
;      71 
;      72                         
;      73 #define offen 1
;      74 #define geschlossen 2
;      75 #define unbekannt 3                                
;      76 #define statusadresse 10
;      77 
;      78 #define f_auf 20
;      79 #define f_zu 30
;      80 #define f_non 40
;      81   
;      82 // b7, b6 = Fernbedienung !
;      83 
;      84 // Declare your global variables here
;      85 int z1,z2,z3;      
;      86 char status;			// Stauts der Schlsser
;      87 char speicherstatus;            // Status im EEPROM
;      88 char altstatus;
;      89 
;      90 // Fernbedienung reinholen
;      91 char get_fernbedienung (void)
;      92  {                        

	.CSEG
_get_fernbedienung:
;      93   if (PINB & 128) return (f_auf);
	IN   R30,0x16
	ANDI R30,LOW(0x80)
	__NEB10 0x2
	LDI  R30,LOW(20)
	RET
;      94   if (PINB & 64) return (f_zu);
_0x2:
	IN   R30,0x16
	ANDI R30,LOW(0x40)
	__NEB10 0x3
	LDI  R30,LOW(30)
	RET
;      95   return (f_non);
_0x3:
	LDI  R30,LOW(40)
	RET
;      96  }        
;      97 
;      98 // Zustand erkennen
;      99 char get_zustand (void)
;     100  {
_get_zustand:
;     101   // char temp;
;     102   
;     103   // Fernbedinung hat immer Vorrang
;     104   if (get_fernbedienung () == f_auf) return (offen);
	RCALL _get_fernbedienung
	__EQB1NJ 0x5,20
	LDI  R30,LOW(1)
	RET
;     105   if (get_fernbedienung () == f_zu) return (geschlossen);
_0x5:
	RCALL _get_fernbedienung
	__EQB1NJ 0x6,30
	LDI  R30,LOW(2)
	RET
;     106   
;     107   if ((PIND & 16) && (PIND & 32)) return (unbekannt); else // Beide 1
_0x6:
	IN   R30,0x10
	ANDI R30,LOW(0x10)
	__NEB10 0x8
	IN   R30,0x10
	ANDI R30,LOW(0x20)
	__NEB10 0x8
	RJMP _0x9
_0x8:
	RJMP _0x7
_0x9:
	LDI  R30,LOW(3)
	RET
_0x7:
;     108    if (!(PIND & 16) && !(PIND & 32)) return (unbekannt); else // Beide 0
	IN   R30,0x10
	ANDI R30,LOW(0x10)
	__EQB10 0xC
	IN   R30,0x10
	ANDI R30,LOW(0x20)
	__EQB10 0xC
	RJMP _0xD
_0xC:
	RJMP _0xB
_0xD:
	LDI  R30,LOW(3)
	RET
_0xB:
;     109  
;     110   if (PIND & 16) return (offen); else // Schlsser offen
	IN   R30,0x10
	ANDI R30,LOW(0x10)
	__NEB10 0xF
	LDI  R30,LOW(1)
	RET
_0xF:
;     111   if (PIND & 32) return (geschlossen); // Schlsser dicht
	IN   R30,0x10
	ANDI R30,LOW(0x20)
	__NEB10 0x11
	LDI  R30,LOW(2)
	RET
;     112  }
_0x11:
_0x10:
_0xE:
_0xA:
	RET
;     113              
;     114 //EEPROM  write
;     115 void write_eeprom (char address, char value)
;     116 {
_write_eeprom:
;     117    while (EECR & 0x02);       //wait for EEWE==0 (EECR.1)
_0x13:
	IN   R30,0x1C
	ANDI R30,LOW(0x2)
	__NEB10 0x14
	RJMP _0x13
_0x14:
;     118    EEAR = address;            //write address to EEAR
	LDD  R30,Y+1
	OUT  0x1E,R30
;     119    EEDR = value;              //wrie data to EEDR
	LD   R30,Y
	OUT  0x1D,R30
;     120    EECR = 0x04;               //set EEMWE=1 (EECR.2)
	LDI  R30,LOW(4)
	OUT  0x1C,R30
;     121    EECR = 0x02;               //set EEWE=1 (EECR.1)
	LDI  R30,LOW(2)
	OUT  0x1C,R30
;     122 }//end function
	ADIW R28,2
	RET
;     123 
;     124 
;     125 //EEPROM  read, returns data byte       
;     126 char read_eeprom (char address)
;     127 {  
_read_eeprom:
;     128    while (EECR & 0x02);       //wait for EEWE==0
_0x16:
	IN   R30,0x1C
	ANDI R30,LOW(0x2)
	__NEB10 0x17
	RJMP _0x16
_0x17:
;     129    EEAR = address;            //write address to (EEAR)
	LD   R30,Y
	OUT  0x1E,R30
;     130    EECR = 0x01;               //set EERE=1 (EECR.0)
	LDI  R30,LOW(1)
	OUT  0x1C,R30
;     131    return (EEDR);
	IN   R30,0x1D
	ADIW R28,1
	RET
;     132 }//end function
;     133            
;     134 // kleine Pause einlegen
;     135 void delay (void)
;     136  {          
_delay:
;     137   for (z1=1;z1<3;z1++)
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	__PUTW1R 4,5
_0x1B:
	LDI  R30,LOW(3)
	LDI  R31,HIGH(3)
	__LTW1RJ 4,5,26
	RJMP _0x1C
_0x19:
	__GETW1R 4,5
	ADIW R30,1
	__PUTW1R 4,5
	RJMP _0x1B
_0x1C:
;     138    for (z2=1;z2<8000;z2++)
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	__PUTW1R 6,7
_0x1F:
	LDI  R30,LOW(8000)
	LDI  R31,HIGH(8000)
	__LTW1RJ 6,7,30
	RJMP _0x20
_0x1D:
	__GETW1R 6,7
	ADIW R30,1
	__PUTW1R 6,7
	RJMP _0x1F
_0x20:
;     139     {
;     140 	#asm("wdr");    
	wdr
;     141     	z3=z1+z2;
	__GETW1R 6,7
	ADD  R30,R4
	ADC  R31,R5
	__PUTW1R 8,9
;     142     }	
	RJMP _0x1D
_0x1E:
	RJMP _0x19
_0x1A:
;     143  }
	RET
;     144  
;     145  // ganz kleine Pause einlegen
;     146 void sdelay (void)
;     147  {          
_sdelay:
;     148    for (z2=1;z2<8000;z2++)
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	__PUTW1R 6,7
_0x24:
	LDI  R30,LOW(8000)
	LDI  R31,HIGH(8000)
	__LTW1RJ 6,7,35
	RJMP _0x25
_0x22:
	__GETW1R 6,7
	ADIW R30,1
	__PUTW1R 6,7
	RJMP _0x24
_0x25:
;     149     {
;     150 	#asm("wdr");    
	wdr
;     151     	z3=z1+z2;
	__GETW1R 6,7
	ADD  R30,R4
	ADC  R31,R5
	__PUTW1R 8,9
;     152     }	
	RJMP _0x22
_0x23:
;     153  }
	RET
;     154                       
;     155 // Schlsser ffnen
;     156 void auf (void)
;     157  {                 
_auf:
;     158   PORTB|=2;    
	SBI  0x18,1
;     159   delay ();
	RCALL _delay
;     160   PORTB&=255-2;          
	CBI  0x18,1
;     161   write_eeprom (statusadresse,offen);
	LDI  R30,LOW(10)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	RCALL _write_eeprom
;     162   status=offen;
	LDI  R30,LOW(1)
	MOV  R10,R30
;     163   speicherstatus=offen;
	MOV  R11,R30
;     164  }
	RET
;     165 
;     166 // Schlsser schliessen
;     167 void zu (void)
;     168  {                 
_zu:
;     169   PORTB|=1;    
	SBI  0x18,0
;     170   delay ();
	RCALL _delay
;     171   PORTB&=255-1;
	CBI  0x18,0
;     172   write_eeprom (statusadresse,geschlossen);
	LDI  R30,LOW(10)
	ST   -Y,R30
	LDI  R30,LOW(2)
	ST   -Y,R30
	RCALL _write_eeprom
;     173   status=geschlossen;
	LDI  R30,LOW(2)
	MOV  R10,R30
;     174   speicherstatus=geschlossen;
	MOV  R11,R30
;     175  }
	RET
;     176 
;     177 
;     178 void main(void)
;     179 {
_main:
;     180 // Declare your local variables here
;     181 
;     182 // Input/Output Ports initialization
;     183 // Port B
;     184 DDRB=0x3f;  // Alles auf Ausgang, B6, B7 = Eingang
	LDI  R30,LOW(63)
	OUT  0x17,R30
;     185 PORTB=0x00;
	CLR  R30
	OUT  0x18,R30
;     186 
;     187 // Port D
;     188 DDRD=0x00;
	OUT  0x11,R30
;     189 PORTD=0xff;
	LDI  R30,LOW(255)
	OUT  0x12,R30
;     190 
;     191 // Timer/Counter 0 initialization
;     192 // Clock source: System Clock
;     193 // Clock value: Timer 0 Stopped
;     194 // Mode: Output Compare
;     195 // OC0 output: Disconnected
;     196 TCCR0=0x00;
	CLR  R30
	OUT  0x33,R30
;     197 TCNT0=0x00;
	OUT  0x32,R30
;     198 
;     199 // Timer/Counter 1 initialization
;     200 // Clock source: System Clock
;     201 // Clock value: Timer 1 Stopped
;     202 // Mode: Output Compare
;     203 // OC1 output: Discon.
;     204 // Noise Canceler: Off
;     205 // Input Capture on Falling Edge
;     206 TCCR1A=0x00;
	OUT  0x2F,R30
;     207 TCCR1B=0x00;
	OUT  0x2E,R30
;     208 TCNT1H=0x00;
	OUT  0x2D,R30
;     209 TCNT1L=0x00;
	OUT  0x2C,R30
;     210 OCR1H=0x00;
	OUT  0x2B,R30
;     211 OCR1L=0x00;
	OUT  0x2A,R30
;     212 
;     213 // External Interrupt(s) initialization
;     214 // INT0: Off
;     215 // INT1: Off
;     216 GIMSK=0x00;
	OUT  0x3B,R30
;     217 MCUCR=0x00;
	OUT  0x35,R30
;     218 
;     219 // Timer(s)/Counter(s) Interrupt(s) initialization
;     220 TIMSK=0x00;
	OUT  0x39,R30
;     221 
;     222 // Analog Comparator initialization
;     223 // Analog Comparator: Off
;     224 // Analog Comparator Input Capture by Timer/Counter 1: Off
;     225 ACSR=0x80;
	LDI  R30,LOW(128)
	OUT  0x8,R30
;     226 
;     227 // Watchdog Timer initialization
;     228 // Watchdog Timer Prescaler: OSC/2048
;     229 WDTCR=0x0F; 
	LDI  R30,LOW(15)
	OUT  0x21,R30
;     230 
;     231 status=get_zustand ();       
	RCALL _get_zustand
	MOV  R10,R30
;     232 speicherstatus=read_eeprom (statusadresse);
	LDI  R30,LOW(10)
	ST   -Y,R30
	RCALL _read_eeprom
	MOV  R11,R30
;     233 
;     234 if (status==unbekannt)
	MOV  R26,R10
	__EQB2NJ 0x29,3
;     235  {                            // Zustand ist Quark, erstmal fr klare Verhltnisse sorgen.....
;     236    if ( (speicherstatus!=offen) && (speicherstatus!=geschlossen) ) // Im EEPROM steht noch scheisse.......
	MOV  R26,R11
	__NEB2NJ 0x2B,1
	MOV  R26,R11
	__NEB2NJ 0x2B,2
	RJMP _0x2C
_0x2B:
	RJMP _0x2A
_0x2C:
;     237      auf ();
	RCALL _auf
;     238    if (status==offen) auf (); else zu ();
_0x2A:
	MOV  R26,R10
	__EQB2NJ 0x2D,1
	RCALL _auf
	RJMP _0x2E
_0x2D:
	RCALL _zu
_0x2E:
;     239  } else
	RJMP _0x2F
_0x29:
;     240  
;     241  { // Stimmt der eindeutige uere Zustand auch mit dem zuletzt gespeichertem berein ?
;     242    if (status!=speicherstatus) 
	__NEBRRJ 11,10,48
;     243     {  // Speichr aktualisieren
;     244      speicherstatus=status;
	MOV  R11,R10
;     245      write_eeprom (statusadresse,speicherstatus);
	LDI  R30,LOW(10)
	ST   -Y,R30
	ST   -Y,R11
	RCALL _write_eeprom
;     246     } 
;     247  }
_0x30:
_0x2F:
;     248 
;     249 // Nu is ein mglicher Fehlerzutand behoben und alles ist beim alten....
;     250        
;     251  status=get_zustand ();			// Neuen Status reinholen
	RCALL _get_zustand
	MOV  R10,R30
;     252 
;     253 while (1)
_0x31:
;     254       {
;     255       #asm("wdr");
	wdr
;     256         
;     257        altstatus=status;			// Alten Zustand ablegen
	MOV  R12,R10
;     258          
;     259        status=get_zustand ();			// Neuen Status reinholen
	RCALL _get_zustand
	MOV  R10,R30
;     260   
;     261        if (altstatus!=status) 			// Eine nderung ist eingetreten
	__NEBRRJ 10,12,51
;     262         {
;     263 	  sdelay ();				// Ganz kurze Pause      
	RCALL _sdelay
;     264 	  status=get_zustand ();        	// Neuen Status noch einmal reinholen
	RCALL _get_zustand
	MOV  R10,R30
;     265         }                                                                       
;     266         
;     267         if (altstatus!=status) 			// Eine nderung ist tatschlich eingetreten
_0x33:
	__NEBRRJ 10,12,52
;     268          {					// Reaktion ist gefragt !
;     269            if (altstatus==offen) zu (); else auf ();
	MOV  R26,R12
	__EQB2NJ 0x35,1
	RCALL _zu
	RJMP _0x36
_0x35:
	RCALL _auf
_0x36:
;     270            
;     271         // Ist der Zustand jetzt eindeutig ? Wenn nicht -> Warten, bis jemand seine Griffel in der Mechanik versenkt hat...
;     272         status=get_zustand ();			// Neuen Status reinholen
	RCALL _get_zustand
	MOV  R10,R30
;     273         while (status==unbekannt)     
_0x37:
	MOV  R26,R10
	__EQB2NJ 0x38,3
;     274         {         
;     275           #asm("wdr");
	wdr
;     276           status=get_zustand ();			// Neuen Status reinholen
	RCALL _get_zustand
	MOV  R10,R30
;     277         }   
	RJMP _0x37
_0x38:
;     278 
;     279          }
;     280        
;     281       };
_0x34:
	RJMP _0x31
_0x32:
;     282 }
	RET
;     283                  


__GLOBAL_INI_TBL:
	.DW  0

	.ORG 0

;INTERRUPT VECTORS
	RJMP __RESET
	RJMP 0
	RJMP 0
	RJMP 0
	RJMP 0
	RJMP 0
	RJMP 0
	RJMP 0
	RJMP 0
	RJMP 0
	RJMP 0
